/*
 * consultes.c
 * Autor: Sergio Blanco Cuaresma
 * Data: Desembre del 2001
 * Descripci: Funcions per realitzar consultes al fitxer
 * de hashing i a l'invertit.
 */
#include <stdio.h>
#include "tipus.h"

// Funci que transforma una data en un nmero el qual pot ser
// comparat lgicament (<,>,==) per saber quina data es + antiga
unsigned long int convert(DATE data){
  return ((data.any*10000)+(data.mes*100)+(data.dia));
}


// Visualitza un mailing per pantalla
void mostrar_mailing(struct tipo_mailing m){
  printf("Codi client: %u\n", m.codi_client);
  printf("Codi mailing: %u\n", m.codi_mailing);
  printf("Data: %i/%i/%i\n", m.data.dia, m.data.mes, m.data.any);
  printf("-------------------------------------\n");
}


// Busca i visualitzar els mailings que complaixin l'estat indicat
// com argument, i que es trobien entre la data1 i la data2.
void consultar_mailing(ESTATM estat, DATE data1, DATE data2){
  FILE *fconsulta, *fmailings;
  struct consulta_mailing consulta;
  struct excedent_mailing excedent;
  struct tipo_mailing mailing;
  unsigned int total=0;
  
  if ((fmailings=fopen("mailings.dat", "rb"))==NULL){
    perror("Mailings");
    exit(1);
  }
  if ((fconsulta=fopen("consultes.dat", "rb"))==NULL){
    perror("Consulta mailings");
    exit(1);
  }
  switch (estat){   // Segons l'estat comencem a buscar en una posici o en un altre
    case PENDENT: // Posici 0
      fread(&consulta, sizeof(struct consulta_mailing), 1, fconsulta);
      while ((consulta.data.dia!=0) && (total<10000)) {   // consulta.data.dia=0 simbolitza verge
        if ((convert(data1)<convert(consulta.data)) && (convert(consulta.data)<convert(data2))){
          fseek(fmailings, consulta.address*sizeof(struct tipo_mailing), SEEK_SET);			// Obtenim mailing mestre
          fread(&mailing, sizeof(struct tipo_mailing), 1, fmailings);
          mostrar_mailing(mailing); // Visualitzem
        }
        total++;
        fread(&consulta, sizeof(struct consulta_mailing), 1, fconsulta);
      }
      break;

    case ENVIAT:  // Posici 10000
      fseek(fconsulta, 10000*sizeof(struct consulta_mailing), SEEK_SET);
      fread(&consulta, sizeof(struct consulta_mailing), 1, fconsulta);
      while ((consulta.data.dia!=0) && (total<10000)) {   // consulta.data.dia=0 simbolitza verge
        // Si es troba entre les dades indicades
        if ((convert(data1)<convert(consulta.data)) && (convert(consulta.data)<convert(data2))){
          fseek(fmailings, consulta.address*sizeof(struct tipo_mailing), SEEK_SET);     // Obtenim mailing mestre
          fread(&mailing, sizeof(struct tipo_mailing), 1, fmailings);
          mostrar_mailing(mailing);
        }
        total++;
        fread(&consulta, sizeof(struct consulta_mailing), 1, fconsulta);
      }
      break;
      
    case CONSULTAT:
      fseek(fconsulta, 20000*sizeof(struct consulta_mailing), SEEK_SET);
      fread(&consulta, sizeof(struct consulta_mailing), 1, fconsulta);
      while ((consulta.data.dia!=0) && (total<10000)) {   // consulta.data.dia=0 simbolitza verge
        // Si es troba entre les dades indicades
        if ((convert(data1)<convert(consulta.data)) && (convert(consulta.data)<convert(data2))){
          fseek(fmailings, consulta.address*sizeof(struct tipo_mailing), SEEK_SET);     // Obtenim mailing mestre
          fread(&mailing, sizeof(struct tipo_mailing), 1, fmailings);
          mostrar_mailing(mailing);
        }
        total++;
        fread(&consulta, sizeof(struct consulta_mailing), 1, fconsulta);
      }
      break;

    case RESPOSTA_AFIRMATIVA:
      fseek(fconsulta, 30000*sizeof(struct consulta_mailing), SEEK_SET);
      fread(&consulta, sizeof(struct consulta_mailing), 1, fconsulta);
      while ((consulta.data.dia!=0) && (total<10000)) {   // consulta.data.dia=0 simbolitza verge
        // Si es troba entre les dades indicades
        if ((convert(data1)<convert(consulta.data)) && (convert(consulta.data)<convert(data2))){
          fseek(fmailings, consulta.address*sizeof(struct tipo_mailing), SEEK_SET);     // Obtenim mailing mestre
          fread(&mailing, sizeof(struct tipo_mailing), 1, fmailings);
          mostrar_mailing(mailing);
        }
        total++;
        fread(&consulta, sizeof(struct consulta_mailing), 1, fconsulta);
      }
      break;

    case RESPOSTA_NEGATIVA:
      fseek(fconsulta, 40000*sizeof(struct consulta_mailing), SEEK_SET);
      fread(&consulta, sizeof(struct consulta_mailing), 1, fconsulta);
      while ((consulta.data.dia!=0) && (total<10000)) {   // consulta.data.dia=0 simbolitza verge
        // Si es troba entre les dades indicades
        if ((convert(data1)<convert(consulta.data)) && (convert(consulta.data)<convert(data2))){
          fseek(fmailings, consulta.address*sizeof(struct tipo_mailing), SEEK_SET);     // Obtenim mailing mestre
          fread(&mailing, sizeof(struct tipo_mailing), 1, fmailings);
          mostrar_mailing(mailing);
        }
        total++;
        fread(&consulta, sizeof(struct consulta_mailing), 1, fconsulta);
      }
      break;
  }

  if (consulta.data.dia!=0){        // Continuar buscant a zona d'excedents (Posici 50000)
    fseek(fconsulta, 50000*sizeof(struct consulta_mailing), SEEK_SET);
    fread(&excedent, sizeof(struct excedent_mailing), 1, fconsulta);
    total=0;
    while ((consulta.data.dia!=0) && (total<15536)) {
      // Si es troba entre les dades indicades
      if ((convert(data1)<convert(excedent.data)) && (convert(excedent.data)<convert(data2)) && (excedent.estat=estat)){
        fseek(fmailings, consulta.address*sizeof(struct tipo_mailing), SEEK_SET);     // Obtenim mailing mestre
        fread(&mailing, sizeof(struct tipo_mailing), 1, fmailings);
        mostrar_mailing(mailing);  // Visualitzar
      }
      total++;
      fread(&excedent, sizeof(struct excedent_mailing), 1, fconsulta);
    }
  }
  fclose(fmailings);
  fclose(fconsulta);
}


// Visualitza per pantalla l'empresa i les seves comandes indicades per l'argument
void mostrar_empresa(FILE *fclients, FILE *fcomandes, unsigned int client_address, long comanda_address){
  struct tipo_client client;
  struct tipo_comanda comanda;

  fseek(fclients, client_address*sizeof(struct tipo_client), SEEK_SET);   // Obtenim client mestre
  fread(&client, sizeof(struct tipo_client), 1, fclients);
  printf("Codi client: %u\n", client.codi_client);
  printf("Nom: %s\n", client.nom);
  printf("Contacte: %s\n", client.contacte);
  printf("Adrea: %s\n", client.adreca);
  printf("Telf: %i\n", client.telf);
  printf("Tipus de client: ");
  if (client.tipo==POTENCIAL){
    printf("Potencial\n");
  } else {
    printf("Real\n");
  }
  printf("\n");
  if (comanda_address!=1){    // comanda_address=1 simbolitza que no hi han comandes per aquest client
    printf("COMANDES:\n\n");
    fseek(fcomandes, comanda_address, SEEK_SET);    // Obtenim comanda mestre
    fread(&comanda, sizeof(struct tipo_comanda), 1, fcomandes);
    while ((client.codi_client==comanda.codi_client) && (!feof(fcomandes))){  // Mentre la comanda sigui del client
      printf("Codi client: %u\n", comanda.codi_client);
      printf("Data: %i/%i/%i\n", comanda.data.dia, comanda.data.mes, comanda.data.any);
      printf("Producte: %s\n", comanda.producte);
      printf("Quantitat: %u\n", comanda.quantitat);
      printf("Preu: %u.%u euros\n", comanda.preu.euros, comanda.preu.centims);
      printf("Estat: ");
      if (comanda.servida==1){
        printf("servida ");
      } else {
        printf("no servida ");
      }
      if (comanda.cobrada==1){
        printf("cobrada");
      } else {
        printf("no cobrada");
      }
      printf("\n\n");
      fread(&comanda, sizeof(struct tipo_comanda), 1, fcomandes);   // Seguent comanda
    }
  }
}


// Busca una empresa pasada com argument i visualitza les seves dades junt
// amb les comandes
void consultar_empresa(char *empresa){
  FILE *fhash, *fclients, *fcomandes;
  struct tipo_hash hash;
  int total=0;
  unsigned int address;

  if ((fclients=fopen("clients.dat", "rb"))==NULL){
    perror("Clients");
    exit(1);
  }
  if ((fcomandes=fopen("comandes.dat", "rb"))==NULL){
    perror("Comandes");
    exit(1);
  }
  if ((fhash=fopen("hashing.dat", "rb"))==NULL){
    perror("Hashing");
    exit(1);
  }

  // Anem a on ens indica la funcion de hashing
  address=T(empresa)*sizeof(struct tipo_hash)*16;	// 16 registres per linea
  fseek(fhash, address, SEEK_SET);
  fread(&hash, sizeof(struct tipo_hash), 1, fhash);	// Busquem els clients amb mateix nom
  // Mostrarem totes les dades de les empreses que coincideixen amb el nom que hem indicat
  while ((total<16) && (strncmp(hash.nom, "*************************", 25)!=0) && (!feof(fhash))){
    if (strncmp(empresa, hash.nom, 25)==0) {
      mostrar_empresa(fclients, fcomandes, hash.client_address, hash.comanda_address);
    }
    fread(&hash, sizeof(struct tipo_hash), 1, fhash); // Seguent
    total++;
  }
  if (total>=16){	// Zona principal plena, hi han mes a la zona d'excedents (Posici 3302)
    address=3302; total=0;
    fread(&hash, sizeof(struct tipo_hash), 1, fhash);
    // Mostrarem totes les dades de les empreses que coincideixen amb el nom que hem indicat
    while ((total<12703) && (strncmp(hash.nom, "*************************", 25)!=0) && (!feof(fhash))) {
      if (strncmp(empresa, hash.nom, 25)==0) {
        mostrar_empresa(fclients, fcomandes, hash.client_address, hash.comanda_address);
      }
      fread(&hash, sizeof(struct tipo_hash), 1, fhash);
      total++;
    }
  }
  fclose(fclients);
  fclose(fcomandes);
  fclose(fhash);
}
