/*
 * crear_fitxers.c
 * Autor: Sergio Blanco Cuaresma
 * Data: Desembre del 2001
 * Descripci: Crea fitxer mestre de clients, mailings, comandes o
 * moviments amb valors per defecte.
 */
#include <stdio.h>
#include "tipus.h"

int main(int argc, char *argv[]){
  FILE *moviments, *clients, *comandes, *mailings, *fconsulta;
  struct tipo_client client;
  struct tipo_comanda comanda;
  struct tipo_mailing mailing;
  struct seguentreg next;
  struct consulta_mailing consulta;
  struct excedent_mailing excedent;
  struct tipo_hash hash;
  unsigned int bucle;

  // Comprovem arguments
  if (argc<2) {
    fprintf(stderr, "s: %s clients/comandes/mailings/moviments\n", argv[0]);
    exit(0);
  }

  // Crear fitxer clients
  if (strcmp("clients", argv[1])==0) {
    if ((clients=fopen("clients.dat", "wb"))==NULL) {
      perror("clients.dat");
      exit(1);
    }
    client.codi_client = 0;  strcpy(client.nom, "Microsoft");
    strcpy(client.contacte, "Bill Gates"); strcpy(client.adreca, "USA"); client.telf=5648; client.tipo=REAL;
    fwrite(&client, sizeof(struct tipo_client), 1, clients);
    client.codi_client = 1;  strcpy(client.nom, "Sun Microsystems");
    strcpy(client.contacte, "Tony Lee"); strcpy(client.adreca, "Av/ Gran via"); client.telf=5638; client.tipo=REAL;
    fwrite(&client, sizeof(struct tipo_client), 1, clients);
    client.codi_client = 2;  strcpy(client.nom, "IBM");
    strcpy(client.contacte, "James White"); strcpy(client.adreca, "C/ Mallorca"); client.telf=1248; client.tipo=REAL;
    fwrite(&client, sizeof(struct tipo_client), 1, clients);
    client.codi_client = 3;  strcpy(client.nom, "HP");
    strcpy(client.contacte, "Rock Steve"); strcpy(client.adreca, "Rambla Nova"); client.telf=53238; client.tipo=POTENCIAL;
    fwrite(&client, sizeof(struct tipo_client), 1, clients);
    client.codi_client = 4;  strcpy(client.nom, "Compac");
    strcpy(client.contacte, "Robert Hurt"); strcpy(client.adreca, "Poligon 23"); client.telf=977253544; client.tipo=POTENCIAL;
    fwrite(&client, sizeof(struct tipo_client), 1, clients);
    client.codi_client = 5;  strcpy(client.nom, "Telefonica");
    strcpy(client.contacte, "John Haunt"); strcpy(client.adreca, "Belgium"); client.telf=177555648; client.tipo=REAL;
    fwrite(&client, sizeof(struct tipo_client), 1, clients);
    fclose(clients);
    printf("Generat fitxer clients.\n");

  // Crear fitxer comandes
  } else if (strcmp("comandes", argv[1])==0) {
    if ((comandes=fopen("comandes.dat", "wb"))==NULL){
      perror("comandes.dat");
      exit(1);
    }
    comanda.codi_client = 0; comanda.codi_comanda = 0; strcpy(comanda.producte, "CPU AMD Athlon 1.333Ghz");
    comanda.data.dia=26; comanda.data.mes=12; comanda.data.any=2001; comanda.quantitat=1; comanda.preu.euros=30;
    comanda.preu.centims=75; comanda.servida=TRUE; comanda.cobrada=TRUE;
    fwrite(&comanda, sizeof(struct tipo_comanda), 1, comandes);

    comanda.codi_client = 0; comanda.codi_comanda = 1; strcpy(comanda.producte, "Soltek 75DRV+");
    comanda.data.dia=30; comanda.data.mes=12; comanda.data.any=2001; comanda.quantitat=1; comanda.preu.euros=40;
    comanda.preu.centims=30; comanda.servida=TRUE; comanda.cobrada=FALSE;
    fwrite(&comanda, sizeof(struct tipo_comanda), 1, comandes);

    comanda.codi_client = 1; comanda.codi_comanda = 2; strcpy(comanda.producte, "Mdul RAM 256 DDR");
    comanda.data.dia=26; comanda.data.mes=12; comanda.data.any=2000; comanda.quantitat=1; comanda.preu.euros=10;
    comanda.preu.centims=0; comanda.servida=TRUE; comanda.cobrada=TRUE;
    fwrite(&comanda, sizeof(struct tipo_comanda), 1, comandes);

    comanda.codi_client = 1; comanda.codi_comanda = 3; strcpy(comanda.producte, "Mdul DIMM 128 MB");
    comanda.data.dia=26; comanda.data.mes=12; comanda.data.any=2001; comanda.quantitat=1; comanda.preu.euros=7;
    comanda.preu.centims=50; comanda.servida=FALSE; comanda.cobrada=TRUE;
    fwrite(&comanda, sizeof(struct tipo_comanda), 1, comandes);

    comanda.codi_client = 3; comanda.codi_comanda = 4; strcpy(comanda.producte, "Pentium IV 1.5Ghz");
    comanda.data.dia=26; comanda.data.mes=12; comanda.data.any=2001; comanda.quantitat=1; comanda.preu.euros=30;
    comanda.preu.centims=0; comanda.servida=TRUE; comanda.cobrada=TRUE;
    fwrite(&comanda, sizeof(struct tipo_comanda), 1, comandes);

    comanda.codi_client = 4; comanda.codi_comanda = 5; strcpy(comanda.producte, "MS Windows XP");
    comanda.data.dia=26; comanda.data.mes=12; comanda.data.any=2001; comanda.quantitat=1; comanda.preu.euros=25;
    comanda.preu.centims=25; comanda.servida=FALSE; comanda.cobrada=FALSE;
    fwrite(&comanda, sizeof(struct tipo_comanda), 1, comandes);

    comanda.codi_client = 5; comanda.codi_comanda = 6; strcpy(comanda.producte, "RedHat 7.2 DeLuxe");
    comanda.data.dia=26; comanda.data.mes=12; comanda.data.any=2001; comanda.quantitat=1; comanda.preu.euros=10;
    comanda.preu.centims=60; comanda.servida=TRUE; comanda.cobrada=TRUE;
    fwrite(&comanda, sizeof(struct tipo_comanda), 1, comandes);
    fclose(comandes);
    printf("Generat fitxer comandes.\n");

  // Crear fitxer mailings
  } else if (strcmp("mailings", argv[1])==0) {
    if ((mailings=fopen("mailings.dat", "wb"))==NULL) {
      perror("mailings.dat");
      exit(1);
    }
  
    mailing.codi_client = 0; mailing.codi_mailing = 0; mailing.estat=PENDENT;
    mailing.data.dia=20; mailing.data.mes=11; mailing.data.any=2001;
    fwrite(&mailing, sizeof(struct tipo_mailing), 1, mailings);

    mailing.codi_client = 1; mailing.codi_mailing = 1; mailing.estat=CONSULTAT;
    mailing.data.dia=10; mailing.data.mes=1; mailing.data.any=2001;
    fwrite(&mailing, sizeof(struct tipo_mailing), 1, mailings);

    mailing.codi_client = 1; mailing.codi_mailing = 2; mailing.estat=RESPOSTA_AFIRMATIVA;
    mailing.data.dia=2; mailing.data.mes=11; mailing.data.any=2001;
    fwrite(&mailing, sizeof(struct tipo_mailing), 1, mailings);

    mailing.codi_client = 2; mailing.codi_mailing = 3; mailing.estat=ENVIAT;
    mailing.data.dia=20; mailing.data.mes=11; mailing.data.any=2001;
    fwrite(&mailing, sizeof(struct tipo_mailing), 1, mailings);

    mailing.codi_client = 5; mailing.codi_mailing = 13; mailing.estat=PENDENT;
    mailing.data.dia=20; mailing.data.mes=11; mailing.data.any=2001;
    fwrite(&mailing, sizeof(struct tipo_mailing), 1, mailings);
    fclose(mailings);
    printf("Generat fitxer mailings.\n");

  // Crear fitxer moviments
  } else if (strcmp("moviments", argv[1])==0) {
	  if ((moviments=fopen("moviments.dat", "wb"))==NULL) {
      perror("moviments.dat");
      exit(1);
    }
    
    next.tipus=COMANDA; next.accio=ALTA;
    comanda.codi_client = 0; comanda.codi_comanda=7; strcpy(comanda.producte, "DVD LG 16x");
    comanda.data.dia=26; comanda.data.mes=12; comanda.data.any=2001; comanda.quantitat=1; comanda.preu.euros=30;
    comanda.preu.centims=75; comanda.servida=TRUE; comanda.cobrada=TRUE;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&comanda, sizeof(struct tipo_comanda), 1, moviments);

    next.tipus=CLIENT; next.accio=MODIFICACIO; client.codi_client = 0;  strcpy(client.nom, "SuSE");
    strcpy(client.contacte, "Ral Puig"); strcpy(client.adreca, "Andorra"); client.telf=37555648; client.tipo=REAL;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&client, sizeof(struct tipo_client), 1, moviments);

    next.tipus=MAILING; next.accio=BAIXA;  mailing.codi_client=0; mailing.codi_mailing=0;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&mailing, sizeof(struct tipo_mailing), 1, moviments);
 
    next.tipus=MAILING; next.accio=ALTA;  mailing.codi_client=1; mailing.codi_mailing=10; mailing.estat=ENVIAT;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&mailing, sizeof(struct tipo_mailing), 1, moviments);
  
    next.tipus=CLIENT; next.accio=MODIFICACIO; client.codi_client = 1;  strcpy(client.nom, "SUN");
    strcpy(client.contacte, "Tony Lee"); strcpy(client.adreca, "Av/ Gran via"); client.telf=5638; client.tipo=REAL;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&client, sizeof(struct tipo_client), 1, moviments);

    next.tipus=COMANDA; next.accio=MODIFICACIO;
    comanda.codi_client = 1; comanda.codi_comanda=3; strcpy(comanda.producte, "Mdul RAM 512 DDR");
    comanda.quantitat=5; comanda.preu.euros=33; comanda.preu.centims=75; comanda.servida=TRUE;
    comanda.data.dia=16; comanda.data.mes=12; comanda.data.any=2001;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&comanda, sizeof(struct tipo_comanda), 1, moviments);
  
    next.tipus=CLIENT; next.accio=MODIFICACIO; client.codi_client = 2;  strcpy(client.nom, "IBM Corp.");
    strcpy(client.contacte, "James White"); strcpy(client.adreca, "C/ Mallorca"); client.telf=1248; client.tipo=REAL;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&client, sizeof(struct tipo_client), 1, moviments);

    next.tipus=MAILING; next.accio=ALTA;  mailing.codi_client=2; mailing.codi_mailing=55; mailing.estat=RESPOSTA_NEGATIVA;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&mailing, sizeof(struct tipo_mailing), 1, moviments);
  
    next.tipus=CLIENT; next.accio=MODIFICACIO; client.codi_client = 2;  strcpy(client.nom, "IBM Corporation");
    strcpy(client.contacte, "James White"); strcpy(client.adreca, "C/ Mallorca"); client.telf=1248; client.tipo=REAL;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&client, sizeof(struct tipo_client), 1, moviments);

    next.tipus=COMANDA; next.accio=ALTA;
    comanda.codi_client = 2; comanda.codi_comanda=15; strcpy(comanda.producte, "Monitor Smile 17 pulgades");
    comanda.data.dia=26; comanda.data.mes=12; comanda.data.any=2001; comanda.quantitat=2; comanda.preu.euros=17;
    comanda.preu.centims=50; comanda.servida=FALSE; comanda.cobrada=TRUE;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&comanda, sizeof(struct tipo_comanda), 1, moviments);
  
    next.tipus=COMANDA; next.accio=MODIFICACIO;
    comanda.codi_client = 4; comanda.codi_comanda=5; strcpy(comanda.producte, "MS Windows XP Profesional");
    comanda.data.dia=26; comanda.data.mes=12; comanda.data.any=2001; comanda.quantitat=1; comanda.preu.euros=25;
    comanda.preu.centims=25; comanda.servida=FALSE; comanda.cobrada=FALSE;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&comanda, sizeof(struct tipo_comanda), 1, moviments);
  
    next.tipus=CLIENT; next.accio=BAIXA; client.codi_client=4;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&client, sizeof(struct tipo_client), 1, moviments);

    next.tipus=CLIENT; next.accio=BAIXA; client.codi_client=5;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&client, sizeof(struct tipo_client), 1, moviments);

    next.tipus=CLIENT; next.accio=ALTA; client.codi_client=5; strcpy(client.nom, "RedHat");
    strcpy(client.contacte, "Anna Millers"); strcpy(client.adreca, "France"); client.telf=536348; client.tipo=REAL;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&client, sizeof(struct tipo_client), 1, moviments);

    next.tipus=COMANDA; next.accio=MODIFICACIO;
    comanda.codi_client = 5; comanda.codi_comanda=6; strcpy(comanda.producte, "RedHat LiNux");
    comanda.data.dia=26; comanda.data.mes=12; comanda.data.any=2001; comanda.quantitat=1; comanda.preu.euros=10;
    comanda.preu.centims=60; comanda.servida=TRUE; comanda.cobrada=TRUE;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&comanda, sizeof(struct tipo_comanda), 1, moviments);

    next.tipus=MAILING; next.accio=MODIFICACIO;  mailing.codi_client=5; mailing.codi_mailing=13; mailing.estat=ENVIAT;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&mailing, sizeof(struct tipo_mailing), 1, moviments);
  
    next.tipus=COMANDA; next.accio=BAIXA;
    comanda.codi_client = 5; comanda.codi_comanda=6;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&comanda, sizeof(struct tipo_comanda), 1, moviments);

    next.tipus=CLIENT; next.accio=ALTA; client.codi_client=6; strcpy(client.nom, "Cisco Systems");
    strcpy(client.contacte, "Steve Weobs"); strcpy(client.adreca, "Round 23"); client.telf=927226301;
    client.tipo=POTENCIAL;
    fwrite(&next, sizeof(struct seguentreg), 1, moviments);
    fwrite(&client, sizeof(struct tipo_client), 1, moviments);
  
    fclose(moviments);
    printf("Generat fitxer moviments.\n");

  // L'argument indicat no correspon a cap vlid
  } else {
    fprintf(stderr, "s: %s clients/comandes/mailings/moviments\n", argv[0]);
    exit(0);
  }
  
  return 0;
}
  
