/*
 * menu.c
 * Autor: Sergio Blanco Cuaresma
 * Data: Desembre del 2001
 * Descripci: Menu amb diverses funcions per poder fer proves
 * i utilitzar tota la prctica d'IBD. Crear clients, comandes,
 * mailings, moviments... actualitza, visualitza, etc...
 */
#include <stdio.h>
#include "tipus.h"

struct tipo_client client;
struct tipo_client *client_ptr;   //Necessari per accedir als bitsfields
struct tipo_comanda comanda;
struct tipo_comanda *comanda_ptr;   //Necessari per accedir als bitsfields
struct tipo_mailing mailing;
struct tipo_mailing *mailing_ptr;   //Necessari per accedir als bitsfields
struct seguentreg moviment;
FILE *fclients, *fcomandes, *fmailings, *fmoviments;
char c, d;


// Llegeix una data per l'entrada standard i la retorna
DATE llegir_data(void){
  DATE data;
  DATE *data_ptr;   //Necessari per accedir als bitsfields
  unsigned int buff;

  data_ptr=&data;
  printf("\tDia: "); scanf("%u", &buff); data_ptr->dia=buff;
  printf("\tMes: "); scanf("%u", &buff); data_ptr->mes=buff;
  printf("\tAny (Mx 8191): "); scanf("%u", &buff); data_ptr->any=buff; getchar();
  return data;
} 


// Llegeix per l'entrada standard un client
void llegir_client(void) {
  unsigned int buff;

  printf("Codi client: "); scanf("%u", &client.codi_client); getchar();
  printf("Nom client: "); //fgets(client.nom, 25, stdin);
  scanf("%[^\n]", client.nom); getchar();
  printf("Contacte: "); //fgets(client.contacte, 29, stdin);
  scanf("%[^\n]", client.contacte); getchar();
  printf("Adrea: "); //fgets(client.adreca, 29, stdin);
  scanf("%[^\n]", client.adreca); getchar();
  printf("Telfon: "); scanf("%u", &buff); client_ptr->telf=buff; getchar();
  printf("\n\t P) Client potencial\n");
  printf("\t R) Client real (Defecte)\n");
  printf("Tipus de client: ");c=tolower(getchar()); getchar();
  if (c == 'p') {
    printf("Seleccionat Potencial\n");
    client.tipo=POTENCIAL;
  } else {
    printf("Seleccionat Real\n");
    client.tipo=REAL;
  }
}


// Llegix per l'entrada standard una comanda
void llegir_comanda(void){
  unsigned int buff;

  printf("Codi comanda: "); scanf("%u", &comanda.codi_comanda);
  printf("Codi client: "); scanf("%u", &comanda.codi_client);
  printf("Data...\n"); printf("\tDia: "); scanf("%u", &buff); comanda_ptr->data.dia=buff;
  printf("\tMes: "); scanf("%u", &buff); comanda_ptr->data.mes=buff;
  printf("\tAny (Mx 8191): "); scanf("%u", &buff); comanda_ptr->data.any=buff; getchar();
  printf("Producte: "); //fgets(comanda.producte, 18, stdin);
  scanf("%[^\n]", comanda.producte); getchar();
  printf("Preu...\n"); printf("\tEuros: "); scanf("%u", &buff); comanda_ptr->preu.euros=buff;
  printf("\tCntims: "); scanf("%u", &buff); comanda_ptr->preu.centims=buff;
  printf("Quantitat: "); scanf("%c", &comanda.quantitat);
  printf("Servida? [s/n] (Defecte no) "); c=tolower(getchar()); getchar();
  if (c == 's'){
    comanda.servida=TRUE;
  } else {
    comanda.servida=FALSE;
  }
  printf("Cobrada? [s/n] (Defecte no) "); c=tolower(getchar()); getchar();
  if (c == 's'){
    comanda.cobrada=TRUE;
  } else {
    comanda.cobrada=FALSE;
  }
}


// Llegeix per l'entrada standard un mailing
void llegir_mailing(void){
  unsigned int buff;

  printf("Codi mailing: "); scanf("%u", &mailing.codi_mailing);
  printf("Codi client: "); scanf("%u", &mailing.codi_client);
  printf("Data...\n"); printf("\tDia: "); scanf("%u", &buff); mailing_ptr->data.dia=buff;
  printf("\tMes: "); scanf("%u", &buff); mailing_ptr->data.mes=buff;
  printf("\tAny (Mx 8191): "); scanf("%u", &buff); mailing_ptr->data.any=buff; getchar();
  printf("\n\t1) Pendent (Defecte)\n");
  printf("\t2) Enviat\n");
  printf("\t3) Consultat\n");
  printf("\t4) Resposta Afirmativa\n");
  printf("\t5) Resposta Negativa\n");
  printf("Estat: "); c=tolower(getchar()); getchar();
  switch (c){
    case '2':
      printf("Seleccionat enviat\n");
      mailing.estat=ENVIAT;
      break;
    case '3':
      printf("Seleccionat consultat\n");
      mailing.estat=CONSULTAT;
      break;
    case '4':
      printf("Seleccionat resposta afirmativa\n");
      mailing.estat=RESPOSTA_AFIRMATIVA;
      break;
    case '5':
      printf("Seleccionat resposta negativa\n");
      mailing.estat=RESPOSTA_NEGATIVA;
      break;
    default:
      printf("Seleccionat pendent\n");
      mailing.estat=PENDENT;
      break;
   }
}

// Principal: Visualitza el menu i realitza les operacions demanades
int main(void){
  char sobre;   // Fer moviment sobre client(1)/comanda(2)/mailing(3)
  char empresa[26];
  DATE data1, data2;
 
  client_ptr=&client;
  comanda_ptr=&comanda;
  mailing_ptr=&mailing;
  
  do{   // MENU
    printf("\n- IBD Prctica -------------------------------\n");
    printf("* 1/2/3/5 noms per fer proves, no s'aplica hashing ni s'usa fitxer invertit a priori.\n");
    printf("1) Crear fitxer mestre de clients\n");
    printf("2) Crear fitxer mestre de comandes\n");
    printf("3) Crear fitxer mestre de mailings\n");
    printf("4) Crear fitxer de moviments\n");
    printf("5) Crear fitxers amb valors per defecte per provar Feijen\n\n");
    printf("6) Actualitzar mestres (Feijen)\n");
    printf("7) Consultar Mailings per estat\n");
    printf("8) Consultar client per nom\n");
    printf("9) Visualitzaci rpida\n\n");
    printf("Q) Sortir\n\n");
    printf("Opci: ");
    c=tolower(getchar());
    getchar();	// Eliminem ENTER

    switch (c) {
      ///////////////////////////////////////////////////////////////////////
      case '1':   // Crear fitxer mestre de clients (no s'aplica hashing ni s'usa fitxer invertit)
        if ((fclients=fopen("clients.dat", "wb"))==NULL){
          perror("clients.dat");
          exit(1);
        }
        do {
          llegir_client();
          fwrite(&client, sizeof(struct tipo_client), 1, fclients); // Guardar registre
          printf("Afegir un altre? [s/n] (Defecte s) "); d=tolower(getchar());
          getchar();  // Eliminamos ENTER
        } while (d!='n');
        fclose(fclients);
        break;

      ///////////////////////////////////////////////////////////////////////
      case '2': // Crear fitxer mestre de comandes (no s'aplica hashing ni s'usa fitxer invertit)
        if ((fclients=fopen("comandes.dat", "wb"))==NULL){
          perror("comandes.dat");
          exit(1);
        }
        do {
          llegir_comanda();
          fwrite(&comanda, sizeof(struct tipo_comanda), 1, fcomandes);
          printf("Afegir un altre? [s/n] (Defecte s) "); d=tolower(getchar());
          getchar();  // Eliminamos ENTER
        } while (d!='n');
        fclose(fcomandes);
        break;
        
      ///////////////////////////////////////////////////////////////////////
      case '3':  // Crear fitxer mestre de mailings (no s'aplica hashing ni s'usa fitxer invertit)
        if ((fmailings=fopen("mailings.dat", "wb"))==NULL){
          perror("mailings.dat");
          exit(1);
        }
        do {
          llegir_mailing;
          fwrite(&mailing, sizeof(struct tipo_mailing), 1, fmailings);
          printf("Afegir un altre? [s/n] (Defecte s) "); d=tolower(getchar());
          getchar();  // Eliminamos ENTER
        } while (d!='n');
        fclose(fmailings);

        break;
        
      ///////////////////////////////////////////////////////////////////////
      case '4':  // Crear fitxer de moviments
        if ((fmoviments=fopen("moviments.dat", "wb"))==NULL){
          perror("moviments.dat");
          exit(1);
        }
        do {
          printf("\t 1) Client (Defecte)");
          printf("\t 2) Comanda\n");
          printf("\t 3) Mailing\n");
          printf("Moviment sobre: "); sobre=tolower(getchar()); getchar();
          printf("\n\t 1) Alta (Defecte)\n");
          printf("\t 2) Baixa\n");
          printf("\t 3) Modificaci\n");
          printf("Tipus de moviment: "); c=tolower(getchar()); getchar();
          switch (c) {
            case '2':
              moviment.accio=BAIXA;
              break;
            case '3':
              moviment.accio=MODIFICACIO;
              break;
            default:
              moviment.accio=ALTA;
              break;
          }
          fwrite(&moviment, sizeof(struct seguentreg), 1, fmoviments);
          switch (sobre){
            case '2':
              moviment.tipus=COMANDA;
              llegir_comanda();
              fwrite(&comanda, sizeof(struct tipo_comanda), 1 , fmoviments);
              break;
            case '3':
              moviment.tipus=MAILING;
              llegir_mailing();
              fwrite(&mailing, sizeof(struct tipo_mailing), 1, fmoviments);
              break;
            default:
              moviment.tipus=CLIENT;
              llegir_client();
              fwrite(&client, sizeof(struct tipo_client), 1, fmoviments);
              break;
          }
          printf("Afegir un altre? [s/n] (Defecte s) "); d=tolower(getchar());
          getchar();  // Eliminamos ENTER
        } while (d!='n');
        fclose(fmoviments);
        break;

      ///////////////////////////////////////////////////////////////////////
      case '5':  // Crear fitxers amb valors per defecte (no s'aplica hashing ni s'usa fitxer invertit)
        printf("Generar clients? [s/n] (Defecte s) ");
        d=tolower(getchar()); getchar();
        if (d!='n') {
          system("./crear clients");
        }
        printf("Generar comandes? [s/n] (Defecte s) ");
        d=tolower(getchar()); getchar();
        if (d!='n') {
          system("./crear comandes");
        }
        printf("Generar mailings? [s/n] (Defecte s) ");
        d=tolower(getchar()); getchar();
        if (d!='n') {
          system("./crear mailings");
        }
        printf("Generar moviments? [s/n] (Defecte s) ");
        d=tolower(getchar()); getchar();
        if (d!='n') {
          system("./crear moviments");
        }
        break;

      ///////////////////////////////////////////////////////////////////////
      case '6':  // Actualitzar mestres (Feijen)
        system("./feijen");
        break;

      ///////////////////////////////////////////////////////////////////////
      case '7':  // Consultar Mailings per estat
        printf("\n\t1) Pendent (Defecte)\n");
        printf("\t2) Enviat\n");
        printf("\t3) Consultat\n");
        printf("\t4) Resposta Afirmativa\n");
        printf("\t5) Resposta Negativa\n");
        printf("Estat: "); c=tolower(getchar()); getchar();
        printf("Data inicial\n");
        data1=llegir_data();
        printf("Data limit\n");
        data2=llegir_data();
        switch (c){
          case '2':
            printf("Seleccionat enviats\n\n");
            consultar_mailing(ENVIAT, data1, data2);
            break;
          case '3':
            printf("Seleccionat consultats\n\n");
            consultar_mailing(CONSULTAT, data1, data2);
            break;
          case '4':
            printf("Seleccionat resposta afirmativa\n\n");
            consultar_mailing(RESPOSTA_AFIRMATIVA, data1, data2);
            break;
          case '5':
            printf("Seleccionat resposta negativa\n\n");
            consultar_mailing(RESPOSTA_NEGATIVA, data1, data2);
            break;
          default:
            printf("Seleccionat pendents\n\n");
            consultar_mailing(PENDENT, data1, data2);
            break;
         }

        break;

      ///////////////////////////////////////////////////////////////////////
      case '8':  // Consultar client per nom
        printf("Empresa: "); //fgets(empresa, 25, stdin);
        scanf("%[^\n]", empresa); getchar();
        consultar_empresa(empresa);
        break;
      ///////////////////////////////////////////////////////////////////////
      case '9':  // Visualitzaci rpida
        printf("\n");
        printf("Visualitzar clients? [s/n] (Defecte s) ");
        d=tolower(getchar()); getchar();
        if (d!='n') {
          system("./visualitzar clients");
        }
        printf("Visualitzar comandes? [s/n] (Defecte s) ");
        d=tolower(getchar()); getchar();
        if (d!='n') {
          system("./visualitzar comandes");
        }
        printf("Visualitzar mailings? [s/n] (Defecte s) ");
        d=tolower(getchar()); getchar();
        if (d!='n') {
          system("./visualitzar mailings");
        }
        printf("Visualitzar moviments? [s/n] (Defecte s) ");
        d=tolower(getchar()); getchar();
        if (d!='n') {
          system("./visualitzar moviments");
        }

       break;
    }
        
  } while (c!='q');
  printf("\n- Alumne: Sergio Blanco Cuaresma\n");
  printf("- IBD, ETIG 2001/02\n");
}
