/*
 * Capalera: Definicions del tipus principals
 * Autor: Sergio Blanco Cuaresma
 * Data: 01/12/2001
 * 
 */

typedef enum { POTENCIAL, REAL } TIPOC;
typedef enum { FALSE, TRUE } BOOLEAN;

typedef struct date {
  unsigned dia:5;
  unsigned mes:4;
  unsigned any:13;
} DATE;

typedef struct euro {
  unsigned int euros;
  char centims;
} EURO;

typedef enum { PENDENT, ENVIAT, CONSULTAT, RESPOSTA_AFIRMATIVA, RESPOSTA_NEGATIVA } ESTATM;

struct tipo_client {
  unsigned int codi_client;
  char nom[26];
  char contacte[30];
  char adreca[30];
  unsigned telf:30;
  TIPOC tipo;
};

struct tipo_comanda {
  unsigned long int codi_comanda;
  DATE data;
  char producte[19];
  unsigned char quantitat;
  EURO preu;
  unsigned int codi_client;
  BOOLEAN servida;
  BOOLEAN cobrada;
};

struct tipo_mailing {
  DATE data;
  unsigned long int codi_mailing;
  unsigned int codi_client;
  ESTATM estat;
};

typedef enum { ALTA, BAIXA, MODIFICACIO } TACCIO;
typedef enum { CLIENT, COMANDA, MAILING } TTIPUS;

struct seguentreg {
  TACCIO accio;
  TTIPUS tipus;
};

// Utilitzat per fer busquedes dins de l'array de registres de mateix codi_client
// agafats d'un fitxer mestre
struct X {
  unsigned int pos;
  BOOLEAN no_trobat;
};


// Registre del fitxer de invertit
struct consulta_mailing {
    unsigned int address;
    DATE data;
};

// Registre del fitxer de invertit (zona d'excedents)
struct excedent_mailing {
  unsigned int address;
  DATE data;
  ESTATM estat;
};

struct tipo_hash {
  char nom[26];
  unsigned int client_address;
  long comanda_address;
};
