/*
 * visualitzar.c
 * Autor: Sergio Blanco Cuaresma
 * Data: Desembre del 2001
 * Descripci: Visualitzar el contingut del fitxer clients, comandes,
 * mailings o moviments
 */
#include <stdio.h>
#include "tipus.h"

// Principal
int main (int argc, char *argv[]) {
  FILE *clients, *comandes, *mailings, *moviments;
  struct tipo_client client;
  struct tipo_comanda comanda;
  struct tipo_mailing mailing;
  struct seguentreg next;

  // Comprovem arguments
  if (argc<2) {
    fprintf(stderr, "s: %s clients/coamandes/mailings/moviments\n", argv[0]);
    exit(0);
  }
  
  // Visualitzem clients
  if (strcmp("clients", argv[1])==0){
    if ((clients=fopen("clients.dat", "rb"))==NULL) {
      perror("clients.dat");
      exit(1);
    }

    printf("Clients............\n");
    fread(&client, sizeof(struct tipo_client), 1, clients);
    while (!feof(clients)){
      printf("Codi client: %i -> Empresa: %s\n", client.codi_client, client.nom);
      fread(&client, sizeof(struct tipo_client), 1, clients);
    }
    fclose(clients);

  // Visualitzem comandes
  } else if (strcmp("comandes", argv[1])==0){
    if ((comandes=fopen("comandes.dat", "rb"))==NULL){
      perror("comandes.dat");
      exit(1);
    }

    printf("\nComandes...........\n");
    fread(&comanda, sizeof(struct tipo_comanda), 1, comandes);
    while (!feof(comandes)){
      printf("Codi client: %i -> Producte: %s\n", comanda.codi_client, comanda.producte);
      fread(&comanda, sizeof(struct tipo_comanda), 1, comandes);
    }
    fclose(comandes);

  // Visualitzem mailings
  } else if (strcmp("mailings", argv[1])==0){
    if ((mailings=fopen("mailings.dat", "rb"))==NULL){
      perror("mailings.dat");
      exit(1);
    }

    printf("\nMailing............\n");
    fread(&mailing, sizeof(struct tipo_mailing), 1, mailings);
    while (!feof(mailings)){
      printf("Codi client: %i -> Codi mailing: %i\n", mailing.codi_client, mailing.codi_mailing);
      fread(&mailing, sizeof(struct tipo_mailing), 1, mailings);
    }
    fclose(mailings);

  // Visualitzem moviments
  } else if (strcmp("moviments", argv[1])==0){
    if ((moviments=fopen("moviments.dat", "rb"))==NULL) {
      perror("moviments.dat");
      exit(1);
    }
    
    printf("Moviments............\n");
    fread(&next, sizeof(struct seguentreg), 1, moviments);  // Mirem quin tipus de moviment ve a continuaci
    while (!feof(moviments)) {
      switch (next.accio) {
        case ALTA:
          printf("Alta de ");
          break;
        case BAIXA:
          printf("Baixa de ");
          break;
        case MODIFICACIO:
          printf("Modificaci de ");
          break;
      }
      switch (next.tipus){    // Segons el tipus, llegim un client, una comanda o un mailing
        case CLIENT:
          printf("client: \t");
          fread(&client, sizeof(struct tipo_client), 1, moviments);
          printf("Codi client: %i -> Empresa: %s\n", client.codi_client, client.nom);
          break;
        case COMANDA:
          printf("comanda:\t");
          fread(&comanda, sizeof(struct tipo_comanda), 1, moviments);
          printf("Codi client: %i -> Producte: %s\n", comanda.codi_client, comanda.producte);
          break;
        case MAILING:
          printf("mailing:\t");
          fread(&mailing, sizeof(struct tipo_mailing), 1, moviments);
          printf("Codi client: %i -> Codi mailing: %i\n", mailing.codi_client, mailing.codi_mailing);
          break;
      }
      fread(&next, sizeof(struct seguentreg), 1, moviments);  // Seguent tipus de moviment
    }
    fclose(moviments);

  // L'argument especificat no es cap vlid
  } else {
    fprintf(stderr, "s: %s clients/coamandes/mailings/moviments\n", argv[0]);
    exit(0);
  }

  return 0;
}
